<?php
namespace Mirasvit\SearchAutocomplete\Controller\Cart\Add;

/**
 * Interceptor class for @see \Mirasvit\SearchAutocomplete\Controller\Cart\Add
 */
class Interceptor extends \Mirasvit\SearchAutocomplete\Controller\Cart\Add implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Checkout\Model\Cart $cart, \Magento\Checkout\Model\Session $session, \Magento\Catalog\Api\ProductRepositoryInterface $productRepository, \Magento\Framework\Serialize\Serializer\Json $serializer, \Magento\Framework\App\Action\Context $context)
    {
        $this->___init();
        parent::__construct($cart, $session, $productRepository, $serializer, $context);
    }

    /**
     * {@inheritdoc}
     */
    public function execute()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'execute');
        return $pluginInfo ? $this->___callPlugins('execute', func_get_args(), $pluginInfo) : parent::execute();
    }

    /**
     * {@inheritdoc}
     */
    public function dispatch(\Magento\Framework\App\RequestInterface $request)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'dispatch');
        return $pluginInfo ? $this->___callPlugins('dispatch', func_get_args(), $pluginInfo) : parent::dispatch($request);
    }
}
